#include "botlist.h"

BotList::BotList( void) {
  first = 0;
}

BotList::~BotList( void) {
  struct sBotList *tmp = first;

  while (first) {
    if (first->data)
      delete first->data;
    tmp = first;
    first = tmp->next;
    delete tmp;
  }
}

void BotList::add( Bot *data) {
  struct sBotList *tmp;

  tmp = new sBotList;
  if (!tmp) {
    delete data;
    return;
  }

  tmp->data = data;
  tmp->next = first;

  first = tmp;
}

void BotList::remove( Bot *data) {
  sBotList *tmp = first;

  if (!tmp) return;

  if (tmp->data == data) {
    delete tmp->data;
    first = tmp->next;
    delete tmp;
    return;
  }

  for (;;) {
    if (tmp->next)
      if (tmp->next->data == data) {
        delete tmp->next->data;
        sBotList *tmp2 = tmp->next;
        tmp->next = tmp->next->next;
        delete tmp2;
        break;
      }
    else
      break;
    tmp = tmp->next;
  }
}

Bot *BotList::getFirst( void) {
  if (!first)
    return( 0);
  return( first->data);
}
