#ifndef CLIST_H
#define CLIST_H

#include "display.h"
#include "bot.h"
#include "cuser.h"

class Display;
class CUser;
class Bot;

struct sCList {
  struct sCList *next;
  CUser         *data;
};

class CList {
    Bot *parent;

    char channame[ 33];
  public:
    struct sCList *first;
    
    CList( Bot *_parent);
    ~CList( void);

    void clear( void);

    int   addUser( CUser *_user);
    int   delUser( char *_username);
    int   delUser( CUser *_user);

    CUser *getFirst( void);
    CUser *getUser( char *_username);
    int   getSize( void);
    
    int   setChannel( char *_channame);
    int   showUsers( Display *disp);
};

#endif
