#include <string.h>
#include "config.h"
#include "mylib.h"
#include "cuser.h"


CUser::CUser( void) {
  bzero( name, sizeof( name));
  bzero( product, sizeof( product));
  flags = latency = 0;
}

CUser::~CUser( void) {
}


int CUser::setName( char *_name) {
  if (!_name) return( -1);
  strncpy( name, _name, sizeof( name) - 1);
  return( 0);
}

int CUser::setFlags( u32 _flags) {
  flags = _flags;
  return( 0);
}

int CUser::setLatency( int _latency) {
  latency = _latency;
  return( 0);
}

int CUser::setProduct( u32 _product) {
  char *tmp = (char *)&_product;

  product2 = _product;

  product[0] = tmp[3];
  product[1] = tmp[2];
  product[2] = tmp[1];
  product[3] = tmp[0];

  return( 0);
}


char *CUser::getName( void) {
  return( name);
}

u32 CUser::getFlags( void) {
  return( flags);
}

int CUser::getLatency( void) {
  return( latency);
}

char *CUser::getProduct( void) {
  return( product);
}

u32 CUser::getProduct2( void) {
  return( product2);
}
