#ifndef DISP_H
#define DISP_H

#include <iostream>
#include <stdio.h>

class DispOutBuf : public std::streambuf {
public:
protected:
	virtual int overflow( int c) {
		if (c != EOF) {
			char ch = c;
			printf("=> %c\n", ch);
		}
		return c;
	}
};

class Disp : public std::ostream {
protected:
	DispOutBuf buf;
public:
	Disp ( void) : std::ostream(0), buf() {
		rdbuf(&buf);
	}
};

#endif
