// DesKey.h: interface for the DesKey class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DESKEY_H__726E239D_6249_479B_8EDA_72636A477DB1__INCLUDED_)
#define AFX_DESKEY_H__726E239D_6249_479B_8EDA_72636A477DB1__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>

class DesKey  
{
public:
	bool operator ==(const DesKey &other) const;
	void calcid();
	unsigned keyid;
	unsigned id() const;
	DesKey(const std::string &k, const std::string &s, const std::string &d);
	DesKey(const DesKey& other);
	bool decrypt(const std::string &data, std::string &result) const;
	void encrypt(const std::string &data, std::string &result) const;
	DesKey();
	virtual ~DesKey();
	std::string description;
	std::string key;
	std::string source;
};

#endif // !defined(AFX_DESKEY_H__726E239D_6249_479B_8EDA_72636A477DB1__INCLUDED_)
