// PubKey.h: interface for the PubKey class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PUBKEY_H__7D8A9C29_BAAA_405A_B0C4_9B674A1346C2__INCLUDED_)
#define AFX_PUBKEY_H__7D8A9C29_BAAA_405A_B0C4_9B674A1346C2__INCLUDED_

#include "rsa/rsa.hpp"	// Added by ClassView
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <string>

class PubKey  
{
public:
	static bool decrypt(const std::string &data, std::string &result, const private_key &pkey);
	bool encrypt(const std::string &data, std::string &result) const;
	PubKey(const PubKey &other);
	public_key key;
	PubKey();
	virtual ~PubKey();
	std::string owner;
};

#endif // !defined(AFX_PUBKEY_H__7D8A9C29_BAAA_405A_B0C4_9B674A1346C2__INCLUDED_)
