#include "config.h"
#include <stdio.h>
#include <pthread.h>
#include <unistd.h>
#include "figlet.h"

void *figlet_start( void *instance) {
	debug(("figlet_start was called"));
	Figlet *figlet = (Figlet *)instance;
	figlet->instance();
	return NULL;
}

Figlet::Figlet( void) {
	//===
	// Start a new thread.
		pthread_create( &thread, 0, figlet_start, this);

	//===
	// Add the thread into the master list.
		
}

Figlet::~Figlet( void) {
}

void Figlet::signal( void) {
}

void Figlet::instance( void) {
	debug(("Figlet::instance was called! THIS SHOULD NOT BE CALLED"));
	usleep( 100000); //sleep( 1);
	debug(("Figlet::instance is trying instance again"));
	instance();
}

//===
// Called from another thread, waiting for this one to exit.
void Figlet::join( void) {
	pthread_join( thread, NULL);
}
