#ifndef GLOBALS_H
#define GLOBALS_H

#include "config.h"

#ifdef DISP_GTK
	#include "tgtk.h"
#endif

#include "tio.h"
#include "db/obj.h"

class Obj;
class TIO;

class Globals {
public:
	Globals( void);
	~Globals( void);

	int done;

	Obj *db;
	Obj *userdb;

	#ifdef DISP_GTK
		TGtk *tgtk;
	#endif
	TIO *tio;

};

extern Globals *globals;

#endif
