#ifndef GTK_MAIN_H
#define GTK_MAIN_H

#include <time.h>
#include "config.h"

#include "gtk_about.h"
#include "gtk_userlist.h"
#include "gtk_log.h"
#include "proxylist.h"

class ProxyList;
class Gtk_About;
class Gtk_UserList;
class Gtk_Log;

class Gtk_Main {
  private:
    ProxyList *proxylist;

    #ifdef DISP_GTK
      GtkWidget *window1;
      GtkWidget *vbox1;  
      GtkWidget *toolbar1;
      GtkWidget *toolbar3;
      GtkWidget *button3; 
      GtkWidget *button4; 
      GtkWidget *button5; 
      GtkWidget *button6;
      GtkWidget *vbox3;   
      GtkWidget *scrolledwindow1;
      GtkWidget *ctree1;
      GtkWidget *label7;
      GtkWidget *label8;
      GtkWidget *label9;
      GtkWidget *label10;
      GtkWidget *label11;
      GtkWidget *label12;
      GtkWidget *button1;
      GtkWidget *button2;
    #endif

    // Idle variables.
      time_t tv;
  public:
    Gtk_UserList *gtk_userlist;
    Gtk_About    *gtk_about;
    Gtk_Log      *gtk_log;

    Gtk_Main( void);
    ~Gtk_Main( void);

    #ifdef DISP_GTK
      GtkCTree *getCTree( void);
    #endif
    
    void     idle( void);
    ProxyList *getProxyList( void);
};

#endif
