#include "globals.h"
#include "input.h"

extern unsigned char zenc_crc( unsigned char *msg);

unsigned char *zenc_Encrypt( unsigned char *msg) {
  static unsigned char buf[ 1024];

  buf[0] = '/';
  while( buf[0] == '/')
    buf[0] = rand() % 224 + 32;

  buf[1] = rand() % 224 + 32;
  buf[2] = ' '; //zenc_crc( msg);
  buf[3] = ' ';
  strcpy( (char *)buf + 4, (char *)msg);
  buf[2] = zenc_crc( buf);

  unsigned int seed = (buf[1] << 8)  + buf[0];

  int i = 4;
  while (*msg) {

    buf[i] = ((*msg + seed) % 224) + 32;  // ((*msg + (seed % 224)) % 224) + 32;
    seed = 69069 * seed + *msg;

    msg++;
    i++;
  }

  buf[i] = 0;
  buf[3] = zenc_crc( buf);

  return( buf);
}

Input::Input( Bot *bot) {
	//pthread_mutex_init( &input_mutex, 0);
	//Q = new std::queue< char *>;
	Input::bot = bot;
	enc_mode = 0;
}

Input::~Input( void) {
	//while (!Q->empty()) {
	//	char *tmp = Q->front();
	//	delete tmp;
	//	Q->pop();
	//}
	//delete Q;
}

void Input::handle( const char *msg2) {
	if (!msg2 || !*msg2) return;
	
	//===
	// Ok, we could be parsed a message w/ a newline.
	// Deal w/ it. :)
	char *msg = new char[ strlen( msg2) + 1];
	strcpy( msg, msg2);

	if (char *t = strchr( msg, '\n')) {
		*t = 0;
		handle( msg);
		handle( t + 1);
		return;
	}

	int found = 0;
	
	//===
	// /dcc send username filename
	if (!strncmp( msg, "/dcc ", 5)) { found++;
		char buf[ 256]; strcpy( buf, msg);
		char *t4 = gettermnz( buf, 4);
		char *t3 = gettermn( buf, 3);
		char *t2 = gettermn( buf, 2);

		if (t2 && !strcmp( t2, "send")) {
			if (!t3 || !t4) {
				*(bot->disp)
					<< endl
					<< CBWHITE << "DCC Error:" << endl << CBGREEN
					<< "  You must include a username to send to, and a filename" << endl;
			} else {
				char *msg = "1.2.3.4 5678 \"filename.txt\"";
				char buf[ 256];
				strncpy( buf, (char *)zenc_Encrypt( (unsigned char *)msg), sizeof( buf) - 1);
				buf[ sizeof( buf) - 1 - 2] = '\0';
				char buf2[256];
				strncpy( buf2, (char *)zenc_Encrypt( (unsigned char *)buf), sizeof( buf2) - 1);
				buf2[ sizeof( buf2) - 1 - 2] = '\0';
								
				bot->enqueue( 1, "%s", buf2);
			}
		}
		if (t2 && !strcmp( t2, "recv")) {
		}
		if (!t2 || !strcmp( t2, "help")) {
			*(bot->disp)
				<< endl
				<< CBWHITE << "DCC Help:" << endl << CBGREEN
				<< "  /dcc send username filename" << endl
				<< "  /dcc recv filenum" << endl
				<< "  /dcc help" << CWHITE << endl;
		}
	}
	
	if (!strcmp( msg, "/crap")) { found++;
		for (int p = 0; p < 1024; p++) {
			char buf[128];
			for (int o = 0; o < sizeof( buf); o++)
				buf[o] = (rand() % 64) + 32;
			buf[127] = 0;
			
			for (int i = 0; i < 1024; i++)
				*(bot->disp) << buf << endl;
		}
	}
	
	if (!strcmp( msg, "/help")) { found++;
		*(bot->disp)
			<< endl
      	<< CBWHITE << "Help:" << endl << CBGREEN
      	<< "  /botnet     - Botnet Information" << endl
      	<< "  /clear      - Clear the screen" << endl
      	<< "  /ver        - zDSBot3 version" << endl
      	<< "  /quit       - Quit" << endl
      	<< "  /info       - Shows the general stats for each bot" << endl
      	<< "  /e          - Encrypt using zEnc" << endl
      	<< "  /emsg       - Private zEnc message" << endl
			<< "    Usage: /emsg user text" << endl
      	<< "  /ev         - Encrypt using the vlbbot method" << endl
      	<< "  /h          - Encrypt using the hex method" << endl
      	<< "  /gmsg - Group Messages" << endl
      	<< "    Usage: /gmsg user [commandgroup]" << endl
      	<< "  /eon        - Sets crypt on" << endl
      	<< "  /eoff       - Sets crypt off" << endl
			<< "  /getpkey    - Get's a profile key for a user (in hex)" << endl
			<< "              - /getpkey bob profile\\sex" << endl
			<< "  /profile    - Get's a profile/keys for a user" << endl
      	<< "  /reconnect  - Reconnects the current bot" << endl
      	<< "  /set        - Shows the list of variables" << endl
      	<< "              - Set's the list of variables" << endl
      	<< "  /status     - Shows some basic status info for each bot" << CWHITE << endl;
	}

	if (!strcmp( msg, "/clear")) { found++;
		bot->disp->cls();
	}
	
	if (!strcmp( msg, "/claer")) { found++;
		bot->disp->cls();
	}
	
	if (!strncmp( msg, "/e ", 3)) { found++;
		char buf[ 256];
		strncpy( buf, (char *)zenc_Encrypt( (unsigned char *)(msg + 3)), sizeof( buf) - 1);
		buf[ sizeof( buf) - 1 - 2] = '\0';

		bot->enqueue( 1, "%s", buf);
	}
	
	if (!strncmp( msg, "/emsg ", 6)) { found++;
		char tmp[ 256];
		strncpy( tmp, msg, sizeof( tmp) - 1);
		
		char *_msg = gettermnz( tmp, 3);
		char *user = gettermn( tmp, 2);
	
		if (user && _msg) {
			char buf[ 256];
			strncpy( buf, (char *)zenc_Encrypt( (unsigned char *)_msg), sizeof( buf) - 1);
			buf[ sizeof( buf) - 1] = 0;

			bot->enqueue( 1, "%s", buf);
		}
	}

	if (!strcmp( msg, "/eon")) { found++;
		enc_mode = 3;
	}
	
	if (!strcmp( msg, "/eoff")) { found++;
		enc_mode = 0;
	}
	
	if (!strcmp( msg, "/reconnect")) { found++;
		bot->netclose();
	}

	if (!strncmp( msg, "/profile ", 9)) { found++;
		bot->getProfile( msg + 9);
	}
	
	if (!strncmp( msg, "/join ", 6)) { found++;
		bot->setHomeChannel( msg + 6);
	}

	if (!strcmp( msg, "/who")) { found++;
		bot->getCList()->showUsers( bot->disp);
	}

	//===
	// Lets you request a random key, ex: profile\publicrsaencryptkey
	if (!strncmp( msg, "/getpkey ", 9)) { found++;
		bot->getPKey( msg + 9);
	}
	
	if (!found) {
		switch (enc_mode) {
			case 3:
				{
					char buf[ 256];
					strncpy( buf, (char *)zenc_Encrypt( (unsigned char *)msg), sizeof( buf) - 1);
					buf[ sizeof( buf) - 1 - 2] = '\0';

					bot->enqueue( 1, "%s", buf);
				} break;
			default:
				bot->enqueue( 1, "%s", msg);
		}
	}

	globals->tio->signal();

	delete msg;
}
