// nice indentation << copied from a man page and havn't changed it :)
       #include <sys/types.h>
       #include <sys/stat.h>
       #include <fcntl.h>


#include <stdlib.h>
//#include <iostream>
#include <fstream>
#include <string.h>
#include <ctype.h>
#include "display.h"
#include "mylib.h"

extern Display disp;

#ifdef WIN32
  #include <windows.h>
#else
  #include <unistd.h>
#endif

// Moonshine- says you should learn iostreams >;-P bah I code my c++ in c >;-)
//void log( char *buf) {
//  ofstream out("log.txt", ios::app );
//  out << buf << endl;
//  out.close();
//}

int hex2num( char ch) {
  switch( ch) {
    case 'F':
    case 'f': return( 15);
    case 'E':
    case 'e': return( 14);
    case 'D':
    case 'd': return( 13);
    case 'C':
    case 'c': return( 12);
    case 'B':
    case 'b': return( 11);
    case 'A':
    case 'a': return( 10);
    case '9': return( 9);
    case '8': return( 8);
    case '7': return( 7);
    case '6': return( 6);
    case '5': return( 5);
    case '4': return( 4);
    case '3': return( 3);
    case '2': return( 2);
    case '1': return( 1);
    default:  return( 0);
  }
}


void trim( char *buf) {
  char *p;
  
  p = buf;

  while ( isspace( *p))
    p++;

  strcpy( buf, p);

  int n;

  if (n = strlen( buf)) {
    p = buf + n - 1;
  
    while ( isspace( *p))
      *p-- = '\0';
  }
}

// todo - fix # inside a ""
void trimHash( char *buf) {
  char *p;

  if (p = strstr( buf, "#"))
    *p = '\0';

  trim( buf);
}

char *gettermn( char *buf, int n) {
  int a = 0; char *p;

  // Find the start.
  while (n) {
    if (*buf == '\0') return( NULL);

    if (isspace( *buf++))
      a = 0;
    else {
      if (!a)
        n--;
      a++;
    }
  }
    
  // Find the end.
  p = --buf;
  while ( !isspace( *p))
    if (!*p)
      break;
    else
      p++;

  *p = '\0';

  return( buf);
}

char *gettermnz( char *buf, int n) {
  int a = 0; char *p;

  // Find the start.
  while (n) {
    if (*buf == '\0') return( NULL);

    if (isspace( *buf++))
      a = 0;
    else {
      if (!a)
        n--;
      a++;
    }
  }
    
  // Find the end.
  p = --buf;
  
  //while ( !isspace( *p))
  //  if (!*p)
  //    break;
  //  else
  //    p++;
  //
  //*p = '\0';

  return( buf);
}

// yes, I know this is in display too heh >;-)
void hexdump(int b, char *buffer, FILE *where) {
	int i, offset, stop;
	unsigned char *p;

	for (offset = 0; offset < b; offset += 16) {

		// Offset
		fprintf( where, "%08X   ", offset);

		// Adjust start
		p = (unsigned char *)&buffer[offset];
		stop = ((offset + 16) > b) ? b - offset : 16;

		// Drop numbers
		for (i = 0; i < stop; i++) {
			if (i == 8) fputs("- ", where);
			fprintf( where, "%02X ", p[i]);
		}

		// Fill
		while (i < 16) {
			if (i++ == 8) fputs("- ", where);
			fputs("   ", where);
		}

		// Space
		fputs("  ", where);

		// Drop characters
		for (i = 0; i < stop; i++) fputc(isgraph(p[i]) ? p[i] : p[i] == ' ' ? ' ' : '.', where);

		// Finish
		fputc('\n', where);
	}

}

// "12-Dec-00" format
char *printDate( time_t t) {
  static char buf[8];
  struct tm *_tm;
  char *months[] = { "Jan", "Feb", "Mar", "Apr", "May", "Jun", 
                     "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

  if (t == 0)
    sprintf( buf, "N/A");
  else {
    _tm = localtime( &t);
    sprintf( buf, "%.2d%s%.2d", _tm->tm_mday, months[_tm->tm_mon], _tm->tm_year % 100);
  }

  return( buf);
}

// "13:45" format
char *printTime( void) {
  static char buf[9];
  struct tm *_tm;

  time_t t = time( 0);
  if (t == 0)
    sprintf( buf, "N/A");
  else {
    _tm = localtime( &t);
    sprintf( buf, "%.2d:%.2d:%.2d", _tm->tm_hour, _tm->tm_min, _tm->tm_sec);
  }

  return( buf);
}

#ifdef WIN32
  //int time( void *tmp) {
  //  return( GetTickCount() / 1000);
  //}

//  int strcasecmp( char *a, char *b) {
//    while (*a) {
//      if (tolower( *a) != tolower( *b)) return( -1);
//      a++;
//      b++;
//      if (!*a && *b) return( -1);
//      if (*a && !*b) return( -1);
//    }
//    return( 0);
//  }

//  int strncasecmp( char *a, char *b, int n) {
//    if (!n) return( 0);
//    while (*a) {
//      if (tolower( *a) != tolower( *b)) return( -1);
//      if (!--n) return( 0);
//      a++;
//      b++;
//      if (!*a && *b) return( -1);
//      if (*a && !*b) return( -1);
//    }
//    return( 0);
//  }


  void bzero( void *s, int n) {
    for (int i = 0; i < n; i++)
      *(char *)(((char *)(s))++) = 0;
  }

#endif

#ifndef WIN32
#include <sys/utsname.h>
// umm...
// #ifdef OS_BSD
//   #include <sys/vfs.h>
// #endif

char *GetUptime( void) {
  static char buf2[ 256];
  static char buf[35];
  double uptime;
  int hr=0, min=0, num;
  char *plural = "";

  bzero( buf2, sizeof( buf2));

  int ud = open("/proc/uptime", O_RDONLY);
  read(ud, buf, sizeof(buf)-1);

  sscanf(buf, "%lf", (double *)&uptime);

  /* Convert uptime in secs to a readable format */
  if (uptime > 86400) {
    num = (int) uptime/86400; /* If > 1 day do the plural 'days' thang */
    if (num > 1) plural = "s";
    sprintf(buf, "%d day%s, ", num, plural);
    uptime = uptime - num * 86400;
    strcat( buf2, buf);
  }

  hr = (int) uptime / 3600;
  uptime = uptime - hr * 3600;

  min = (int) uptime / 60;
  int sec = (int)uptime;

  sprintf(buf, "%.02d:%.02d:%.02d", hr, min, sec % 60);
  
  strcat( buf2, buf);
  return( buf2);
}

#endif
