#ifndef SENDCDKEYCHECK_H
#define SENDCDKEYCHECK_H

  #include "config.h"

  #ifndef ROTL
    #define ROTL(x,n,w) (((n)%(w)) ? (((x)<<((n)%(w))) | ((x)>>((w)-((n)%(w))))) : (x))
  #endif
  #ifndef ROL
    #define ROL(x,n) ROTL(x,n,32)
  #endif

  #ifndef WIN32
    #ifndef u8
      #define u8 unsigned char
    #endif
    #ifndef u16
      #define u16 unsigned short
    #endif
    #ifndef u32
      #define u32 unsigned int
    #endif
  #endif

  //#ifdef WIN32
  //  void HashData(LPVOID lpSource, int nLength, LPVOID lpResult);
  //#else

  void HashData( void *lpSource, int nLength, void *lpResult);

  //#endif

  //#ifdef WIN32
  //  char * __stdcall SendCDKeyCheck(LPCTSTR lpszCDKey, DWORD dwServerHashKey, LPCTSTR lpszUserName);
  //#else

  char *SendCDKeyCheck( char *lpszCDKey, u32 dwServerHashKey, char *lpszUserName, u32 timestamp, u32 spawn);
  //char *SendCDKeyCheckD2Exp( char *lpszCDKey, char *key2, u32 dwServerHashKey,
  //                      char *lpszUserName, u32 timestamp,
  //                      char *lpszValueString, char *lpszMpqFileName);

  //#endif

  int DecodeCDKey( char *lpszCDKey, u32 *lpdwProductId, u32 *lpdwValue1, u32 * lpdwValue2);
  int DecodeStarcraftKey( char *key);
  int DecodeD2Key( char *key);

  char Get_Hex_Value( u32 v);
  int Get_Num_Value( char c);

#endif
