#ifndef USER_H
#define USER_H

#include "userlist.h"
#include "config.h"

class UserList;

class User {
  UserList *parent;
  
  char name[33];
  int  access, flags;
  char banmessage[ 129];

  u32  offset;

public:
  User( UserList *_parent);
  ~User( void);

  int setName( char *_name);
  int setAccess( int _access);
  int setFlags( int _flags);
  int setBanMessage( char *_message);
  int setOffset( u32 _offset);

  char *getName( void);
  int  getAccess( void);
  int  getFlags( void);
  char *getBanMessage( void);
  u32  getOffset( void);

  int  save( void);
  int  load( u32 offset);
};

#endif
