// ENTIRE FILE MFT !!!

#include <string.h>
#include "display.h"
#include "input.h"
#include "config.h"
#include "vars.h"
#include "mylib.h"

Vars::Vars( void) {
  first = 0;
}

Vars::~Vars( void) {
}

void Vars::showVars( Display *disp, Input *input) {
  struct sVars *tmp = first; int i = 0;

  *disp << CBWHITE << "Vars:  ";

  while (tmp) {
    if (i)
      *disp << "       ";

    *disp << CBPURPLE << tmp->name;
    i = strlen( tmp->name);

    if (i < 20)
      for (;i < 20; i++)
        *disp << " ";

    *disp << " " << CWHITE << tmp->data << CWHITE << endl;

    tmp = tmp->next;
  }
  //if (input)
  //  input->update();
}

void Vars::setVar( char *var, char *data) {
  struct sVars *tmp = first;

  while (tmp) {
    if (!strcasecmp( tmp->name, var)) {
      delete tmp->data;
      tmp->data = new char[ strlen( data) + 1];
      strcpy( tmp->data, data);
      return;
    }
    tmp = tmp->next;
  }

  tmp = new sVars;
  tmp->next = first;
  tmp->name = new char[ strlen( var) + 1];
  strcpy( tmp->name, var);
  tmp->data = new char[ strlen( data) + 1];
  strcpy( tmp->data, data);

  first = tmp;
}

char *Vars::getVar( char *var) {
  struct sVars *tmp = first;

  while (tmp) {
    if (!strcasecmp( tmp->name, var))
      return( tmp->data);
    tmp = tmp->next;
  }

  return( 0);
}
