#include "../config.h"
#ifdef DISP_GTK

#include "../support.h"
#include "../tools/build.h"
#include "wndabout.h"
#include "Pixmaps/about.xpm"
#include <stdio.h>

void onWndAbout_unrealize( GtkWidget *widget, gpointer user_data) {
}

void on_button45_clicked( GtkButton *button, gpointer user_data) {
	gtk_widget_hide( ((WndAbout *)user_data)->wndabout);
}

WndAbout::WndAbout( void) {
	wndabout = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (wndabout), "wndabout", wndabout);
	gtk_container_set_border_width (GTK_CONTAINER (wndabout), 2);
	char buf[256];
	sprintf( buf, "zDSBot3 (build %d) - About\0________________________________________________________________", BUILD);
	gtk_window_set_title (GTK_WINDOW (wndabout), buf);
	gtk_window_set_default_size( (GtkWindow *)wndabout, 400, 250);

	vbox16 = gtk_vbox_new (FALSE, 0);
	//gtk_widget_ref (vbox16);
	//gtk_object_set_data_full (GTK_OBJECT (wndabout), "vbox16", vbox16,
   //                         (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox16);
  gtk_container_add (GTK_CONTAINER (wndabout), vbox16);

  notebook2 = gtk_notebook_new ();
  //gtk_widget_ref (notebook2);
  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "notebook2", notebook2,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook2);
  gtk_box_pack_start (GTK_BOX (vbox16), notebook2, TRUE, TRUE, 0);

  pixmap5 = create_xpm( wndabout, about_xpm);
  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "pixmap5", pixmap5,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap5);
  gtk_container_add (GTK_CONTAINER (notebook2), pixmap5);

  label91 = gtk_label_new( "Logo");
  //gtk_widget_ref (label91);
  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "label91", label91,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label91);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 0), label91);

  scrolledwindow15 = gtk_scrolled_window_new( 0, 0);
  //gtk_widget_ref (scrolledwindow15);
  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "scrolledwindow15", scrolledwindow15,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow15);
  gtk_container_add (GTK_CONTAINER (notebook2), scrolledwindow15);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow15), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

//GTK2 fixme
//  text8 = gtk_text_new(0, 0);
//  //gtk_widget_ref (text8);
//  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "text8", text8,
//  //                          (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (text8);
//  gtk_container_add (GTK_CONTAINER (scrolledwindow15), text8);

	//===
	// If we want to insert a bunch of text, here is a good place to do so.
//GTK2 fixme
//		gtk_text_insert (GTK_TEXT (text8), 0, 0, 0, "", 0);

  label92 = gtk_label_new ("Special Thanks");
  //gtk_widget_ref (label92);
  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "label92", label92,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label92);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook2), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook2), 1), label92);

  hseparator5 = gtk_hseparator_new ();
  //gtk_widget_ref (hseparator5);
  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "hseparator5", hseparator5,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator5);
  gtk_box_pack_start (GTK_BOX (vbox16), hseparator5, FALSE, TRUE, 5);

  hbuttonbox16 = gtk_hbutton_box_new ();
  //gtk_widget_ref (hbuttonbox16);
  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "hbuttonbox16", hbuttonbox16,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox16);
  gtk_box_pack_start (GTK_BOX (vbox16), hbuttonbox16, FALSE, TRUE, 8);

  button45 = gtk_button_new_with_label( "Sweet!");
  //gtk_widget_ref (button45);
  //gtk_object_set_data_full (GTK_OBJECT (wndabout), "button45", button45,
  //                          (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button45);
  gtk_container_add (GTK_CONTAINER (hbuttonbox16), button45);
  GTK_WIDGET_SET_FLAGS (button45, GTK_CAN_DEFAULT);

  //gtk_signal_connect (GTK_OBJECT (wndabout), "destroy",
  //                    GTK_SIGNAL_FUNC (on_wndabout_destroy),
  //                    this);
  gtk_signal_connect (GTK_OBJECT (wndabout), "unrealize",
                      GTK_SIGNAL_FUNC (onWndAbout_unrealize),
                      this);
  gtk_signal_connect (GTK_OBJECT (button45), "clicked",
                      GTK_SIGNAL_FUNC (on_button45_clicked),
                      this);

  gtk_widget_show( wndabout);
}

WndAbout::~WndAbout( void) {
}

#endif
