#include "config.h"
#include "wndalert.h"
#include "../tools/build.h"
#include <stdio.h>

void on_wndalert_destroy( GtkObject *object, gpointer user_data) {
}


void on_button44_clicked( GtkButton *button, gpointer user_data) {
}

WndAlert::WndAlert( const char *msg) {
  wndalert = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (wndalert), "wndalert", wndalert);
  char buf[ 256];
  sprintf( buf, "zDSBot3 (build %d) - Alert\0________________________________________________________________", BUILD);
  gtk_window_set_title (GTK_WINDOW (wndalert), buf);
  gtk_window_set_policy (GTK_WINDOW (wndalert), TRUE, TRUE, FALSE);

  dialog_vbox7 = GTK_DIALOG (wndalert)->vbox;
  gtk_object_set_data (GTK_OBJECT (wndalert), "dialog_vbox7", dialog_vbox7);
  gtk_widget_show (dialog_vbox7);

  label85 = gtk_label_new(msg);
  gtk_widget_show (label85);
  gtk_box_pack_start (GTK_BOX (dialog_vbox7), label85, TRUE, TRUE, 2);
  gtk_label_set_line_wrap (GTK_LABEL (label85), TRUE);

  dialog_action_area7 = GTK_DIALOG (wndalert)->action_area;
  gtk_object_set_data (GTK_OBJECT (wndalert), "dialog_action_area7", dialog_action_area7);
  gtk_widget_show (dialog_action_area7);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area7), 10);

  hbuttonbox15 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox15);
  gtk_box_pack_start (GTK_BOX (dialog_action_area7), hbuttonbox15, TRUE, TRUE, 0);

  button44 = gtk_button_new_with_label ("Yeah, ok...");
  gtk_widget_show (button44);
  gtk_container_add (GTK_CONTAINER (hbuttonbox15), button44);
  GTK_WIDGET_SET_FLAGS (button44, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (wndalert), "destroy",
                      GTK_SIGNAL_FUNC (on_wndalert_destroy),
                      this);
  gtk_signal_connect (GTK_OBJECT (button44), "clicked",
                      GTK_SIGNAL_FUNC (on_button44_clicked),
                      this);

  gtk_widget_show( wndalert);
}

WndAlert::~WndAlert( void) {
  gtk_widget_destroy( wndalert);
}
