#include <string.h>
#include "wndmodules.h"
#include "../globals.h"
#include "../tools/build.h"

//#include "../../../src/modules/modules.h"
//#include "../../../src/modlist.h"

void on_clist77_select_row( GtkCList *clist, gint row, gint column, GdkEvent *event, gpointer user_data) {
	((WndModules *)user_data)->show( row);
}


void on_button466_clicked( GtkButton *button, gpointer user_data) {
  delete( (WndModules *)user_data);
}   


WndModules::WndModules( void) {
	wndmodules = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_object_set_data (GTK_OBJECT (wndmodules), "wndmodules", wndmodules);

	char buf[ 1024];
	sprintf( buf, "zDSBot3 (build %d) - Modules", BUILD);
	gtk_window_set_title (GTK_WINDOW (wndmodules), buf);
	gtk_window_set_default_size (GTK_WINDOW (wndmodules), 400, 250);

	vbox17 = gtk_vbox_new (FALSE, 0);
	gtk_widget_ref (vbox17);
	gtk_object_set_data_full (GTK_OBJECT (wndmodules), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (vbox17);
	gtk_container_add (GTK_CONTAINER (wndmodules), vbox17);

	hbox41 = gtk_hbox_new (FALSE, 0);
	gtk_widget_ref (hbox41);
	gtk_object_set_data_full (GTK_OBJECT (wndmodules), "hbox41", hbox41,
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hbox41);
	gtk_box_pack_start (GTK_BOX (vbox17), hbox41, TRUE, TRUE, 0);

	frame1 = gtk_frame_new ("Module");
	gtk_widget_ref (frame1);
	gtk_object_set_data_full (GTK_OBJECT (wndmodules), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (frame1);
	gtk_box_pack_start (GTK_BOX (hbox41), frame1, TRUE, TRUE, 2);

	scrolledwindow18 = gtk_scrolled_window_new( 0, 0);
	gtk_widget_ref (scrolledwindow18);
	gtk_object_set_data_full (GTK_OBJECT (wndmodules), "scrolledwindow18", scrolledwindow18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow18);
  gtk_container_add (GTK_CONTAINER (frame1), scrolledwindow18);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow18),
GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clistModule = gtk_clist_new (1);
  gtk_widget_ref (clistModule);   
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "clistModule",
clistModule,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clistModule);
  gtk_container_add (GTK_CONTAINER (scrolledwindow18), clistModule);
  gtk_clist_set_column_width (GTK_CLIST (clistModule), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (clistModule));

  label93 = gtk_label_new ("label93");
  gtk_widget_ref (label93);
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "label93", label93,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label93);
  gtk_clist_set_column_widget (GTK_CLIST (clistModule), 0, label93);

  vbox18 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox18);
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "vbox18", vbox18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox18);
  gtk_box_pack_start (GTK_BOX (hbox41), vbox18, TRUE, TRUE, 0);

  frame2 = gtk_frame_new ("Version");
  gtk_widget_ref (frame2);
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "frame2", frame2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox18), frame2, FALSE, TRUE, 0);
  gtk_widget_set_usize (frame2, -2, 85);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);

  scrolledwindow17 = gtk_scrolled_window_new( 0, 0);
  gtk_widget_ref (scrolledwindow17);
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "scrolledwindow17",
scrolledwindow17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow17);
  gtk_container_add (GTK_CONTAINER (frame2), scrolledwindow17);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow17),
GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

//GTK2 FIXME
//	textVersion = (GtkText *)gtk_text_new ( 0, 0);
//  gtk_widget_ref (textVersion);
//  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "textVersion",
//textVersion,
//                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (textVersion);
//  gtk_container_add (GTK_CONTAINER (scrolledwindow17), textVersion);

  frame3 = gtk_frame_new ("Description");
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox18), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 2);  

  scrolledwindow16 = gtk_scrolled_window_new( 0, 0);
  gtk_widget_ref (scrolledwindow16);
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "scrolledwindow16", scrolledwindow16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow16);
  gtk_container_add (GTK_CONTAINER (frame3), scrolledwindow16);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow16), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

//GTK2 FIXME
//  textDesc = gtk_text_new( 0, 0);
//  gtk_widget_ref (textDesc);
//  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "textDesc", textDesc,
//                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (textDesc);
//  gtk_container_add (GTK_CONTAINER (scrolledwindow16), textDesc);

  hbuttonbox17 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox17);
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "hbuttonbox17", hbuttonbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox17);
  gtk_box_pack_start (GTK_BOX (vbox17), hbuttonbox17, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbuttonbox17), 5);   

  button46 = gtk_button_new_with_label ("Sweet!");
  gtk_widget_ref (button46);
  gtk_object_set_data_full (GTK_OBJECT (wndmodules), "button46", button46,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button46);
  gtk_container_add (GTK_CONTAINER (hbuttonbox17), button46);
  GTK_WIDGET_SET_FLAGS (button46, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (clistModule), "select_row",
                      GTK_SIGNAL_FUNC (on_clist77_select_row),
                      this);
  gtk_signal_connect (GTK_OBJECT (button46), "clicked",
                      GTK_SIGNAL_FUNC (on_button466_clicked),
                      this);

	//===
	// Add each module to the list.
	{
		char *mods[4] = { "disp-gtk-alt", "disp-gtk-default", "disp-opengl-default", "server-file" };
		for (int i = 0; i < 3; i++) {
			char *buf[] = { "" };
			int n = gtk_clist_append( (GtkCList *)clistModule, buf);
			gtk_clist_set_text( (GtkCList *)clistModule, n, 0, mods[i]);
		}
	}

//zds
//		sModules *tmp = globals->modules->first;
//		while (tmp) {
//			char *buf[] = { "" };
//			int n = gtk_clist_append( (GtkCList *)clistModule, buf);
//			gtk_clist_set_text( (GtkCList *)clistModule, n, 0, tmp->name);
//			tmp = tmp->next;
//		}

  gtk_widget_show( wndmodules);
}

WndModules::~WndModules( void) {
	gtk_widget_hide( wndmodules);
}

void WndModules::show( int row) {
	char *modname = NULL;
	gtk_clist_get_text( (GtkCList *)clistModule, row, 0, &modname);

	//===
	// First search through built-in modules.
//zds
//		extern sModList mods[];
//		for (int i = 0; mods[i].name; i++)
//			if (!strcasecmp( modname, mods[i].name)) {
//				gtk_text_backward_delete( GTK_TEXT( textVersion), gtk_text_get_length( GTK_TEXT( textVersion)));
//				gtk_text_backward_delete( GTK_TEXT( textDesc), gtk_text_get_length( GTK_TEXT( textDesc)));
//				
//				char *ver   = globals->modules->getVer( modname);
//				char *about = globals->modules->getAbout( modname);
//				if (ver)
//					gtk_text_insert( (GtkText *)textVersion, 0, 0, 0, ver, strlen( ver));
//				if (about)
//					gtk_text_insert( (GtkText *)textDesc, 0, 0, 0, about, strlen( about));
//				
//				return;
//			}

	//===
	// Let's find the module.
//zds
//		sModules *tmp = globals->modules->first;
//		while (tmp) {
//			if (!strcasecmp( modname, tmp->name)) {
//				gtk_text_backward_delete( GTK_TEXT( textVersion), gtk_text_get_length( GTK_TEXT( textVersion)));
//				gtk_text_backward_delete( GTK_TEXT( textDesc), gtk_text_get_length( GTK_TEXT( textDesc)));
//				
//				char *ver = globals->modules->getVer( tmp->hndl);
//				char *about = globals->modules->getAbout( tmp->hndl);
//				if (ver)
//					gtk_text_insert( (GtkText *)textVersion, 0, 0, 0, ver, strlen( ver));
//				if (about)
//					gtk_text_insert( (GtkText *)textDesc, 0, 0, 0, about, strlen( about));
//
//				return;
//			}
//			tmp = tmp->next;
//		}
}
