#include <stdio.h>
#include "../tools/build.h"
#include "config.h"
#include "wndquotes.h"

WndQuotes::WndQuotes( void) {
  wndquotes = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (wndquotes), "wndquotes", wndquotes);
	char buf[ 256];
	sprintf( buf, "zDSBot3 (build %d) - Quotes\0________________________________________________________________", BUILD);
  gtk_window_set_title (GTK_WINDOW (wndquotes), buf);
  gtk_window_set_policy (GTK_WINDOW (wndquotes), TRUE, TRUE, FALSE);
  gtk_window_set_default_size( (GtkWindow *)wndquotes, 400, 300);

  #ifdef WIN32
    dialog_vbox3 = GTK_DIALOG (wndquotes)->action_area;
  #else
    dialog_vbox3 = GTK_DIALOG (wndquotes)->vbox;
  #endif
  gtk_object_set_data (GTK_OBJECT (wndquotes), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  scrolledwindow4 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow4);
  gtk_object_set_data_full (GTK_OBJECT (wndquotes), "scrolledwindow4", scrolledwindow4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow4);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), scrolledwindow4, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow4), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

//GTK2 fixme
//  text2 = gtk_text_new (NULL, NULL);
//  gtk_widget_ref (text2);
//  gtk_object_set_data_full (GTK_OBJECT (wndquotes), "text2", text2,
//                            (GtkDestroyNotify) gtk_widget_unref);
//  gtk_widget_show (text2);
//  gtk_container_add (GTK_CONTAINER (scrolledwindow4), text2);
//	gtk_text_set_editable (GTK_TEXT (text2), TRUE);

  dialog_action_area3 = GTK_DIALOG (wndquotes)->action_area;
  gtk_object_set_data (GTK_OBJECT (wndquotes), "dialog_action_area3", dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area3), 10);

  hbuttonbox7 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox7);
  gtk_object_set_data_full (GTK_OBJECT (wndquotes), "hbuttonbox7", hbuttonbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox7);
  gtk_box_pack_start (GTK_BOX (dialog_action_area3), hbuttonbox7, TRUE, TRUE, 0);

  button28 = gtk_button_new_with_label ("Sweet!");
  gtk_widget_ref (button28);
  gtk_object_set_data_full (GTK_OBJECT (wndquotes), "button28", button28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button28);
  gtk_container_add (GTK_CONTAINER (hbuttonbox7), button28);
  GTK_WIDGET_SET_FLAGS (button28, GTK_CAN_DEFAULT);

  gtk_widget_show( wndquotes);
}

WndQuotes::~WndQuotes( void) {
  gtk_widget_destroy( wndquotes);
}
