#ifndef CAS_H
#define CAS_H

#include "network.h"
#include "bot.h"

class Cas : public Network {
  time_t last_t;
  int port;
  int ready;
public:
  Cas( void);
  ~Cas( void);

  int idle( void);

  int pkt_00( int pkt_len, char *pkt_buf);
  int pkt_01( int pkt_len, char *pkt_buf);
  int pkt_02( int pkt_len, char *pkt_buf);
  int pkt_03( int pkt_len, char *pkt_buf);
  int pkt_04( int pkt_len, char *pkt_buf);
  int pkt_05( int pkt_len, char *pkt_buf);
  int pkt_06( int pkt_len, char *pkt_buf);
  
  int pkt_handler( int pkt_len, char *pkt_buf);

  int SendCheckRevWar2( Bot *bot, char *authequ, char *mpq);
  int SendCheckRevStar( Bot *bot, char *authequ, char *mpq);
  int SendCheckRevSCJap( Bot *bot, char *authequ, char *mpq);

  int SendCDKeyWar2( Bot *bot, char *cdkey, u32 session_key, char *reg, u32 rnd, u32 spawn);
  int SendCDKeyStar( Bot *bot, char *cdkey, u32 session_key, char *reg, u32 rnd, u32 spawn);

  int isReady( void);

  int netclose( void);
};

#endif
