#ifndef DYNCMD_H
#define DYNCMD_H

// Todo: A linked list and a binary tree are both fairly poor implementations.
//       A "standardized" data class for abc style data needs to be made.

#include "bot.h"

struct sDynCmd {
  sDynCmd *next;
  char *command;
  char *action;
};

class DynCmd {
  sDynCmd *first, *keyfirst;
public:
  DynCmd( void);
  ~DynCmd( void);

  void clear( void);

  int add( char *_command, char *_action);
  int del( Bot *bot, char *_command);
  int addkey( char *_command, char *_action);
  int delkey( Bot *bot, char *_command);
  void handle( Bot *bot, char *_username, char *_command, char *_args);
  void list( Bot *bot);
};

#endif
