//=============================================================================
//= zDSBot by Eurijk! *** FILTERED ***                                        =

#ifndef NETWORK_H
#define NETWORK_H

#ifdef WIN32
  #include <time.h>
#else
  #include <sys/time.h>
#endif
#include "config.h"
// #include "psuedo.h"

#ifdef DISP_GTK
  #include <gtk/gtk.h>
#endif

class Network {
  int fd;

  char pkt_buf[ 512];
  int  pkt_loc;

  char pre_buf[ 8192];
  int  pre_len;

  int  crypt;
  // Psuedo psuedo_recv, psuedo_send;

  int proxystate;
  time_t contime;

  u32 counter_recv, counter_send;
  int  is_connected;

  // todo: clean this up
  char rawserver[ 256];
  char username[ 256];

  #ifdef DISP_GTK
    guint gtk_readfd, gtk_writefd, gtk_exceptfd;
  #endif
public:

  Network( void);
  ~Network( void);

  virtual int handler( void);
  int netopen( char *addr, u16 port, char *paddr, u16 pport, char *username, char *vhost);
  virtual int netclose( void);

  int rawsend( int len, char *buf);
  int sendpkt( u16 type);
  int sendpktdebug( u16 type);
  int sendpktdebug2( u16 type);

  int getfd( void);
  int getproxystate( void);
  
  u32 getCountRecv( void);
  u32 getCountSend( void);
  
  time_t getUpTime( void);
  int setproxystate( int _state);
  virtual int setfd( int _fd);

  int getCrypt( void);

  Network& operator<<( char *buf);
  Network& operator<<( u8  i);
  Network& operator<<( u16 i);
  Network& operator<<( u32 i);

  int rawAdd( int len, char *buf);
  virtual int pkt_handler( int len, char *buf);
  virtual int pkt_connected( void);

  int setCrypt( int seed_recv, int seed_send);
  time_t getCTime( void);
  virtual int selectWrite( void);
};

#endif
