#include "proxylist.h"
#include "mylib.h"

ProxyList::ProxyList( void) { //Gtk_Main *_gtkmain) {
  first = 0;
//  gtkmain = _gtkmain;
}

ProxyList::~ProxyList( void) {
  while (first) {
    sProxyList *tmp = first->next;
    if (first->proxy)
      delete first->proxy;
    if (first->next)
      delete first->next;
    first = tmp;
  }
}

void ProxyList::add( Proxy *proxy) {
  sProxyList *tmp = new sProxyList;
  tmp->next = first;
  tmp->proxy = proxy;
  first = tmp;
}

void ProxyList::del( Proxy *proxy) {
  if (!first) return;

  if (first->proxy == proxy) {
    delete first->proxy;
    sProxyList *tmp = first->next;
    delete first;
    first = tmp;
    return;
  }

  sProxyList *tmp = first;
  while (tmp) {
    if (tmp->next)
      if (tmp->next->proxy == proxy) {
        sProxyList *tmp2 = tmp->next;
        tmp->next = tmp2->next;
        if (tmp2->proxy)
          delete tmp2->proxy;
        delete tmp2;
        return;
      }
    tmp = tmp->next;
  }
}

void ProxyList::idle( void) {
  // gtk_ctree_node_set_text( gtkmain->getCTree(),
  //                          ASDF, 1, printTime());
  sProxyList *tmp = first;
  while (tmp) {
    if (tmp->proxy)
      tmp->proxy->idle();
    tmp = tmp->next;
  }
}
