#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>

#include "server.h"

void *server_start( void *arg) {
	((Server *)arg)->instance();
	return NULL;
}

//===
// Simply bind to the port, or keep trying to if we cannot.
Server::Server( char *bindto, int bindport) {
	//===
	// Init variables
		done = 0;

	//===
	// Grab our socket.
		sockfd = socket(AF_INET, SOCK_STREAM, 0);
		if (sockfd == -1)
			throw "Unable to create a socket.";

	//===
	// Fix for "Address already in use"
		int yes = 1;
		if (setsockopt(sockfd,SOL_SOCKET,SO_REUSEADDR,&yes,sizeof(int)) == -1)
			throw "Setsockopt unable to setsockotp.";

	//===
	// Setup the bind.
		struct sockaddr_in my_addr;
		my_addr.sin_family = AF_INET;
		my_addr.sin_port = htons(bindport);
		if (!bindto)
			my_addr.sin_addr.s_addr = INADDR_ANY;
		else
			my_addr.sin_addr.s_addr = inet_addr(bindto);
		memset(&(my_addr.sin_zero), '\0', 8);

	//===
	// Set up a new thread.
		if (pthread_create( &th, NULL, server_start, this))
			throw "Unable to create thread";
}

Server::~Server( void) {
	//===
	// Let the thread know it is finished.
		done++;
		sendsignal();

	//===
	// Wait for the thread to exit.
		pthread_join( th, NULL);
}

void Server::instance( void) {
	int isbound = 0;

	while (!done) {
		//===
		// Try and bind the port.
			if (!isbound) {
				
			}

		//===
		// Queue and delete the sessions

		//===
		// Select on all the open fds's

		//===
		// Handle the accepts.

		//===
		// Call the associated handles

		//===
		// Call the idle handlers

		//===
		// All done
			sleep( 1);
	}
}

void Server::sendsignal( void) {
	// write( ...
}
