#include "config.h"
#ifdef DISP_GTK
  #include <gtk/gtk.h>

GtkWidget* create_xpm( GtkWidget *widget, gchar **xpm) {
  GtkWidget *pixmap;
  GdkColormap *colormap;
  GdkPixmap *gdkpixmap;
  GdkBitmap *mask;
  gchar *pathname;

  colormap = gtk_widget_get_colormap( widget);
  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d( 0, colormap, &mask, 0, xpm);

  if (gdkpixmap == NULL)
    g_error ("Couldn't create replacement pixmap.");

  pixmap = gtk_pixmap_new (gdkpixmap, mask);
  gdk_pixmap_unref (gdkpixmap);
  gdk_bitmap_unref (mask);
  return pixmap;
}

#endif

