#ifndef TAGBAN_H
#define TAGBAN_H

#include "enqueue.h"

struct sTagBan {
  struct sTagBan *next;
  char           *data;
};

class TagBan {
  private:
    sTagBan *first;

  public:
    TagBan( void);
    ~TagBan( void);
    
    int  tagCmp( char *wildcard, char *msg);

    void clear( void);
    int  isBanned( char *msg);
    
    int  exist( char *msg);

    int  tagAdd( char *msg);
    int  tagDel( char *msg);
    int  tagShow( Enqueue *enqueue);
};

#endif
