#ifndef USERLIST_H
#define USERLIST_H

#include "user.h"
class User;

struct sUserList {
  struct sUserList *next;
  User *data;
};

class UserList {
  int fd;
  int save;

public:
  sUserList *first;

  UserList( void);
  ~UserList( void);
  
  void add( User *data);
  void remove( User *data);

  User *getFirst( void);
  User *getUser( char *name);

  int setDatabase( char *filename);
  int saveUser( User *user);
};

#endif
