#include "wndabout.h"
#ifdef DISP_GTK
#  include "logo1.xpm"


int on_wndAbout_delete_event( GtkWidget *widget, gpointer user_data) {
  //gtk_widget_hide( ((WndAbout *)user_data)->wndAbout);
  //delete ((WndAbout *)user_data);
  return 1;
}

void on_button1_clicked( GtkButton *button, gpointer user_data) {
  delete ((WndAbout *)user_data);
}

WndAbout::WndAbout( void) {
  wndAbout = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (wndAbout), "wndAbout", wndAbout);
  gtk_window_set_title (GTK_WINDOW (wndAbout), "zDSBot3 - About - by Eurijk!");
  gtk_window_set_policy (GTK_WINDOW (wndAbout), FALSE, FALSE, FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (wndAbout), vbox1);

  frame1 = gtk_frame_new ( 0);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);

  {
    GdkBitmap *mask;
    GdkColormap *colormap = gtk_widget_get_colormap ( (GtkWidget *)wndAbout);
    GdkPixmap *gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d( 0, colormap, &mask, 0,logo1_xpm);
    pixmap1 = gtk_pixmap_new( gdkpixmap, mask);
    gdk_pixmap_unref( gdkpixmap); 
    gdk_bitmap_unref( mask);

    // pixmap1 = create_pixmap (wndAbout, "logo1.xpm");
  }
  gtk_widget_show (pixmap1);
  gtk_container_add (GTK_CONTAINER (frame1), pixmap1);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, TRUE, 2);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox1, FALSE, TRUE, 0);

  button1 = gtk_button_new_with_label ("Sweet!");
  gtk_widget_show (button1);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), button1);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (wndAbout), "delete-event",
                      GTK_SIGNAL_FUNC (on_wndAbout_delete_event), this);

  //gtk_signal_connect (GTK_OBJECT (wndAbout), "destroy",
  //                    GTK_SIGNAL_FUNC (on_wndAbout_destroy),
  //                    NULL);

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_button1_clicked), this);

  gtk_widget_show( wndAbout);
}

WndAbout::~WndAbout( void) {
  gtk_widget_hide( wndAbout);
  gtk_widget_destroy( button1);
  gtk_widget_destroy( hbuttonbox1);
  gtk_widget_destroy( hseparator1);
  gtk_widget_destroy( pixmap1);
  gtk_widget_destroy( frame1);
  gtk_widget_destroy( vbox1);
  gtk_widget_destroy( wndAbout);
}

#endif
