#ifndef WNDDISP_H
#define WNDDISP_H

#include "config.h"
#include "display.h"
#include "bot.h"

class Bot;

#ifdef DISP_GTK
#  include <gtk/gtk.h>
#endif


class WndDisp : public Display {
public:
  #ifdef DISP_GTK
    GdkPixmap *pixmap[12];
    GdkBitmap *mask[12];

    GtkWidget *wnddisp;
    GtkWidget *vbox1;
    GtkWidget *hpaned1;
    GtkWidget *vbox2;
    GtkWidget *frame5;
    GtkWidget *scrolledwindow2;
    GtkWidget *text1;
    GtkWidget *vbox3;
    GtkWidget *vbox4;
    GtkWidget *frame7;
    GtkWidget *hbox1;
    GtkWidget *toolbar2;
    GtkWidget *tmp_toolbar_icon;
    GtkWidget *btnClear;
    GtkWidget *btnProp;
    GtkWidget *btnUnk;
    GtkWidget *btnFont;
    GtkWidget *vseparator1;
    GtkWidget *checkbutton1;
    GtkWidget *frame6;
    GtkWidget *scrolledwindow3;
    GtkWidget *clist1;
    GtkWidget *label6;
    GtkWidget *label7;
    GtkWidget *label8;
    GtkWidget *frame1;
    GtkWidget *entry1;
    GtkTooltips *tooltips;
    GdkFont   *font;
  #endif

  Bot *parent;

  WndDisp( Bot *parent);
  ~WndDisp( void);

  int addUser( char *name, u32 flags, u32 client, u32 latency);
  int updateUser( char *name, u32 flags, u32 client, u32 latency);
  void delUser( char *name);
  void setChan( char *);

  void print( char *str, ... );
  WndDisp& operator<<( char *msg);
  WndDisp& operator<<( char ch);
  WndDisp& operator<<( int i);
  WndDisp& operator<<( unsigned int i);

  int show( void);
  int hide( void);

  void handleInput( GtkEditable *editable);
  int  handleCmd( char *cmd);
  void handle( void);
};

#endif
