#include "wndfont.h"
#ifdef DISP_GTK

void
on_wndFont_unrealize                   (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_wndFont_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{

}


void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_apply_button1_clicked               (GtkButton       *button,
                                        gpointer         user_data) {
  ((WndFont *)user_data)->parent->ourfont = gtk_font_selection_dialog_get_font( (GtkFontSelectionDialog *)((WndFont *)user_data)->wndFont);
}


WndFont::WndFont( Window *_parent) {
  parent = _parent;

  wndFont = gtk_font_selection_dialog_new ("Select Font");
  gtk_object_set_data (GTK_OBJECT (wndFont), "wndFont", wndFont);
  gtk_container_set_border_width (GTK_CONTAINER (wndFont), 4);
  gtk_window_set_policy (GTK_WINDOW (wndFont), FALSE, TRUE, TRUE);

  ok_button1 = GTK_FONT_SELECTION_DIALOG (wndFont)->ok_button;
  gtk_object_set_data (GTK_OBJECT (wndFont), "ok_button1", ok_button1);
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  cancel_button1 = GTK_FONT_SELECTION_DIALOG (wndFont)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (wndFont), "cancel_button1", cancel_button1);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);

  apply_button1 = GTK_FONT_SELECTION_DIALOG (wndFont)->apply_button;
  gtk_object_set_data (GTK_OBJECT (wndFont), "apply_button1", apply_button1);
  gtk_widget_show (apply_button1);
  GTK_WIDGET_SET_FLAGS (apply_button1, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (wndFont), "unrealize",
                      GTK_SIGNAL_FUNC (on_wndFont_unrealize),
                      this);
  gtk_signal_connect (GTK_OBJECT (wndFont), "destroy",
                      GTK_SIGNAL_FUNC (on_wndFont_destroy),
                      this);
  gtk_signal_connect (GTK_OBJECT (ok_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_button1_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (cancel_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_button1_clicked),
                      this);
  gtk_signal_connect (GTK_OBJECT (apply_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_apply_button1_clicked),
                      this);

  gtk_widget_show( wndFont);
}

WndFont::~WndFont( void) {
}

#endif
